/* tslint:disable */
/* eslint-disable */
/**
 * opGUI - OpenAPI 3.0
 * Dummy description about the available endpoints Some useful links: - [The opGUI repository](https://gitlab.eclipse.org/eclipse/openpass/opgui) - [The documentation page](https://www.eclipse.org/openpass/content/html/index.html)
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import type {
  ConfigElement,
  Default200Response,
  Error400,
  Error500,
} from '../models';
import {
    ConfigElementFromJSON,
    ConfigElementToJSON,
    Default200ResponseFromJSON,
    Default200ResponseToJSON,
    Error400FromJSON,
    Error400ToJSON,
    Error500FromJSON,
    Error500ToJSON,
} from '../models';

export interface ApiConfigElementsPostRequest {
    configElement: Array<ConfigElement>;
}

/**
 * 
 */
export class SetConfigElementsApi extends runtime.BaseAPI {

    /**
     * Set config elements
     */
    async apiConfigElementsPostRaw(requestParameters: ApiConfigElementsPostRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<Default200Response>> {
        if (requestParameters.configElement === null || requestParameters.configElement === undefined) {
            throw new runtime.RequiredError('configElement','Required parameter requestParameters.configElement was null or undefined when calling apiConfigElementsPost.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/api/configElements`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: requestParameters.configElement.map(ConfigElementToJSON),
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => Default200ResponseFromJSON(jsonValue));
    }

    /**
     * Set config elements
     */
    async apiConfigElementsPost(requestParameters: ApiConfigElementsPostRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<Default200Response> {
        const response = await this.apiConfigElementsPostRaw(requestParameters, initOverrides);
        return await response.value();
    }

}
